﻿Imports System.ComponentModel

Public Class DynamicCollection(Of T)
    Inherits BindingList(Of T)
    Implements ITypedList

    Private _pdc As PropertyDescriptorCollection = GetPropertyDescriptorCollection()
    Private ReadOnly Property Pdc As PropertyDescriptorCollection
        Get
            Return _pdc
        End Get
    End Property

    Private _originalPdc As PropertyDescriptorCollection = TypeDescriptor.GetProperties(GetType(IGridLine))
    Public Function GetItemProperties(ByVal listAccessors() As System.ComponentModel.PropertyDescriptor) As System.ComponentModel.PropertyDescriptorCollection Implements System.ComponentModel.ITypedList.GetItemProperties
        Return Pdc
    End Function

    Public Function GetListName(ByVal listAccessors() As System.ComponentModel.PropertyDescriptor) As String Implements System.ComponentModel.ITypedList.GetListName
        Return "DynamicCollection"
    End Function

    Private Function GetPropertyDescriptorCollection() As PropertyDescriptorCollection
        Dim originalPdc As PropertyDescriptorCollection = TypeDescriptor.GetProperties(GetType(IGridLine))
        Dim newPdc As PropertyDescriptorCollection = New PropertyDescriptorCollection(New PropertyDescriptor() {originalPdc("InfraChilds")})

        newPdc.Add(New CustomPropertyDescriptor("Column1"))
        newPdc.Add(New CustomPropertyDescriptor("Column2"))
        newPdc.Add(New CustomPropertyDescriptor("Column3"))
        newPdc.Add(New CustomPropertyDescriptor("Column4"))
        newPdc.Add(New CustomPropertyDescriptor("Column5"))


        Return newPdc
    End Function
End Class